;Generuj typ na vydn, vychz z Tip1684:   LTXT.LSP      Linetype Generator     (c)2001, Darren Marker
;XANADu 2010
;
(vl-load-com)
;(setq _LTFLY_DoNotUseU T) - nepouvat "U" v 2011+

(defun C:LTFLY ( / rep aux oexpert ismetric LTNAME LTNAME0 LT_FILEn LT_F pts cdate redefining)

(defun BBOX (text / doc mspace obj minb maxb pts)
;GetBoundingBox center
  (setq doc (vla-get-ActiveDocument (vlax-get-acad-object)))
  (setq mspace (vla-get-ModelSpace doc))
  (vla-addtext mspace text (vlax-3d-point '(0 0 0)) 1.0) ; text bod vyska
  (setq obj (vlax-ename->vla-object (entlast))); rovnou?
  (vla-put-ScaleFactor obj 1.0)
;(vlax-dump-object obj)
 (if(vlax-method-applicable-p obj 'getboundingbox)
  (progn
    (vla-GetBoundingBox obj 'minb 'maxb)
	(setq minb(vlax-safearray->list minb))
	(setq maxb(vlax-safearray->list maxb))
	(setq pts (list (trans minb 0 1) (trans maxb 0 1)))
  ))
;  (PRINT PTS)
;  (getstring)
  (entdel (entlast))
  (list (caar pts)(caadr pts))
);defun

;----------------------------------
  (setvar "cmdecho" 0)
  (setq oexpert (getvar "expert"))
  (if (not _LTFLYtext)
    (setq _LTFLYtext "ABC")
  ) ;_ end of if
  (if (/=(strcase(getvar "TEXTSTYLE")) "STANDARD")
   (progn
    (princ (strcat "\nThe current text style is not set to \"Standard\" - make sure your current style \"" (getvar "TEXTSTYLE") "\" is available in the target drawing!"))
    (vlr-beep-reaction)
   ))
  (setq rep T)
  (while rep
  (setq aux
         (getstring
           (strcat
             "\nEnter the text (current style) to embed <"
             _LTFLYtext
             ">: "
           ) ;_ end of strcat
         ) ;_ end of getstring
  ) ;_ end of setq
  (if (> aux "")(setq _LTFLYtext aux))
  (if (> _LTFLYtext "")(setq rep nil))
  ) ;_ end of rep
  (setq LTNAME (strcase _LTFLYtext)  LTNAME0 LTNAME  cdate (rtos (getvar "CDATE") 2 8))
  (if (not (snvalid LTNAME0))(setq LTNAME0 (strcat (getvar "LOGINNAME")(substr cdate (+ 2 (vl-string-search "." cdate))))))
  (setq redefining (tblsearch "LTYPE" LTNAME0)); u existuje
  ;---- zeptej se zda m bt stle iteln (jen >=2011): R-->U
;make it
;
  (setvar "expert" 4)
  (setq pts (BBOX _LTFLYtext))
  (setq LTNAME_W (abs (-(cadr pts)(car pts))))
;; (PRINT LTNAME_W)
;  (setq LTNAME_L (strlen LTNAME))
;  (setq LTNAME_W (rtos (* LTNAME_L 0.1) 2 1))
  (setq ismetric (= 1 (getvar "measurement")))

  ;A,12.7,-5.08,["GAS",STANDARD,S=2.54,R=0.0,X=-2.54,Y=-1.27],-6.35 --- ISO
 ;A,.5,-.2,["GAS",STANDARD,S=.1,R=0.0,X=-0.1,Y=-.05],-.25 -- INCH
  (setq LT_FILEn (vl-filename-mktemp "ltfly_temp.lin"))
  (setq LT_F (open LT_FILEn "w"))
  (write-line
         (strcat
           "*" LTNAME0 ","  LTNAME "----" LTNAME "----" LTNAME "----"
           LTNAME
          ) ;_ end of strcat
	LT_F
  ) ;_ end of writeline
  (write-line
         (strcat
           "A," (if ismetric "12.7,-5.08" ".5,-.2") ",["
           (chr 34)
           _LTFLYtext
           (chr 34)
           "," (getvar "TEXTSTYLE") ",S=" (if ismetric "2.54" ".1") 
		   (if (and (> (atof(getvar"ACADVER")) 18.0) (not _LTFLY_DoNotUseU)) ",U=0.0," ",R=0.0,") ; je-li to A2011+ a nen zakzno, pouij U, jinak R
		   (if ismetric "X=-2.54,Y=-1.27" "X=-0.1,Y=-.05") "],-" ; pop. U=0.0 (2011)
           (rtos (- (* LTNAME_W (if ismetric 2.54 0.1)) (if ismetric 1.14 0.04)) 2 2)
         ) ;_ end of strcat
	LT_F
  ) ;_ end of writeline
  (close LT_F)
  (command "_-linetype" "_lo" LTNAME0 LT_FILEn "")
  ;(vl-file-delete LT_FILEn)
  (setvar "expert" oexpert)
  (princ (strcat "\nLinetype \"" LTNAME0 "\" " (if redefining (strcat "updated - use " (getcname "_REGEN")) (strcat "created - use " (getcname "_LINETYPE")))))
  (prin1)
) ;_ end of defun

(princ "\nLTFLY command loaded. (C)2010, XANADU - www.xanadu.cz")
(princ "\n__ CAD, PLM, GIS/FM custom application development __ ")

(if (not XanaduAddApp)(defun XanaduAddApp (a b c d) nil))
(XanaduAddApp "LTFLY" "1.2" '("LTFLY") "Generate txt complex line on the fly")

(prin1)
